routes/web.php
<?php

use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::middleware(['lang'])->group(function () {

    Route::get('/', 'HomeController@index')->name('home');
    Route::group(['namespace' => 'Admin', 'prefix' => 'admin', 'as' => 'admin.'], function () {

        Route::get('login', 'LoginController@login')->name('login');
        Route::post('login', 'LoginController@loginPost')->name('loginPost');
        Route::post('logout', 'LoginController@logout')->name('logout');

        Route::group(['middleware' => ['auth', 'AdminCheck']], function () {

            Route::get('/', 'DashboardController@dashboard')->name('home');
            Route::get('settings', 'DashboardController@settings')->name('settings');
            Route::post('settings', 'DashboardController@settingsPost');

            Route::resources([
                'users' => 'UserController',
                'roles' => 'RoleController',
                'sliders' => 'SliderController',
                'tags' => 'TagController',
                'categories' => 'CategoryController',
                'blogs' => 'BlogController',
                'pages' => 'PageController',
                'banners' => 'BannerController',
                'services' => 'ServiceController',
                'orders' => 'OrderController',
                'partners' => 'PartnerController',
                'payments' => 'PaymentController',
                'coupons' => 'CouponController',
                'shipments' => 'ShipmentController',
                'rates' => 'RateController',
                'contacts' => 'ContactController',
                'projects' => 'ProjectController',
                'products' => 'ProductController',
                'consultancies' => 'ConsultancyController',
                'materials' => 'MaterialController',
            ]);

        });
    });
    Route::group(['namespace' => 'Furniture', 'prefix' => 'furniture', 'as' => 'furniture.'], function () {

        Route::get('login', 'LoginController@login')->name('login');
        Route::post('login', 'LoginController@loginPost');
        Route::post('logout', 'LoginController@logout')->name('logout');

        Route::group(['middleware' => ['auth', 'FurnitureCheck']], function () {

            Route::get('/', 'DashboardController@dashboard')->name('home');

            Route::resources([
                'users' => 'UserController',
                'roles' => 'RoleController',
                'sliders' => 'SliderController',
                'tags' => 'TagController',
                'categories' => 'CategoryController',
                'blogs' => 'BlogController',
                'pages' => 'PageController',
                'banners' => 'BannerController',
                'services' => 'ServiceController',
                'orders' => 'OrderController',
                'partners' => 'PartnerController',
                'payments' => 'PaymentController',
                'coupons' => 'CouponController',
                'shipments' => 'ShipmentController',
                'rates' => 'RateController',
                'contacts' => 'ContactController',
                'projects' => 'ProjectController',
                'products' => 'ProductController',
                'consultancies' => 'ConsultancyController',
                'materials' => 'MaterialController',
            ]);

        });
    });
    Route::group(['namespace' => 'Contractor', 'prefix' => 'contractor', 'as' => 'contractor.'], function () {

        Route::get('login', 'LoginController@login')->name('login');
        Route::post('login', 'LoginController@loginPost');
        Route::post('logout', 'LoginController@logout')->name('logout');

        Route::group(['middleware' => ['auth', 'ContractorCheck']], function () {

            Route::get('/', 'DashboardController@dashboard')->name('home');

            Route::resources([
                'users' => 'UserController',
                'roles' => 'RoleController',
                'sliders' => 'SliderController',
                'tags' => 'TagController',
                'categories' => 'CategoryController',
                'blogs' => 'BlogController',
                'pages' => 'PageController',
                'banners' => 'BannerController',
                'services' => 'ServiceController',
                'orders' => 'OrderController',
                'partners' => 'PartnerController',
                'payments' => 'PaymentController',
                'coupons' => 'CouponController',
                'shipments' => 'ShipmentController',
                'rates' => 'RateController',
                'contacts' => 'ContactController',
                'projects' => 'ProjectController',
                'products' => 'ProductController',
                'consultancies' => 'ConsultancyController',
                'materials' => 'MaterialController',
            ]);

        });
    });
    Route::group(['namespace' => 'Designer', 'prefix' => 'designer', 'as' => 'designer.'], function () {

        Route::get('login', 'LoginController@login')->name('login');
        Route::post('login', 'LoginController@loginPost');
        Route::post('logout', 'LoginController@logout')->name('logout');

        Route::group(['middleware' => ['auth', 'DesignerCheck']], function () {

            Route::get('/', 'DashboardController@dashboard')->name('home');

            Route::resources([
                'users' => 'UserController',
                'roles' => 'RoleController',
                'sliders' => 'SliderController',
                'tags' => 'TagController',
                'categories' => 'CategoryController',
                'blogs' => 'BlogController',
                'pages' => 'PageController',
                'banners' => 'BannerController',
                'services' => 'ServiceController',
                'orders' => 'OrderController',
                'partners' => 'PartnerController',
                'payments' => 'PaymentController',
                'coupons' => 'CouponController',
                'shipments' => 'ShipmentController',
                'rates' => 'RateController',
                'contacts' => 'ContactController',
                'projects' => 'ProjectController',
                'products' => 'ProductController',
                'consultancies' => 'ConsultancyController',
                'materials' => 'MaterialController',
            ]);

        });
    });
});

app/Http/Controllers/Admin/BannerController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Models\Banner;
use Illuminate\Http\Request;
use Illuminate\Support\Str;

class BannerController extends Controller
{
    public function __construct()
    {
        $this->middleware(['permission:banners management']);
    }

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {

        $items = Banner::paginate(10);
        if (request()->is('api/*')) {
            return response()->json($items);
        } else {
            return view('admin.banners.index', compact('items'));
        }
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('admin.banners.add');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param \Illuminate\Http\Request $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {

        $request->validate([
            'name' => 'required|array',
            'image' => 'required|image',
            'url' => 'required'
        ]);


        $item =  Banner::create([
            'image' => $request->image->store('banners'),
            'url' => request('url')
        ]);

        foreach (config('app.locales') as $locale) {
            $item->translates()->updateOrCreate(
                [
                    'language' => $locale,
                    'key' => 'name',
                ],
                [
                    'value' => request('name')[$locale] ? request('name')[$locale] : ""
                ]
            );

        }


        foreach (config('app.locales') as $locale) {
            $item->translates()->updateOrCreate(
                [
                    'language' => $locale,
                    'key' => 'description',
                ],
                [
                    'value' => request('description')[$locale] ? request('description')[$locale] : ""
                ]
            );

        }

        return redirect()->route('admin.banners.index')->with(['success' => 'تم الحفظ بنجاح']);
    }

    /**
     * Display the specified resource.
     *
     * @param int $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param int $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $item = Banner::findOrFail($id);

        if (request()->is('api/*')) {
            return response()->json(['item' => $item]);
        } else {
            return view('admin.banners.edit', compact('item'));
        }

    }

    /**
     * Update the specified resource in storage.
     *
     * @param \Illuminate\Http\Request $request
     * @param int $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {


        $item = Banner::findOrFail($id);
        $data = [];
        if ($request->has('image')) {
            $data['image'] = $request->image->store('banners');
        }
        if ($request->has('url')) {
            $data['url'] = $request->url;
        }
        if ($request->status >= 0) {
            $data['status'] = $request->status;
        }
        $item->update($data);

        foreach (config('app.locales') as $locale) {
            $item->translates()->updateOrCreate(
                [
                    'language' => $locale,
                    'key' => 'name',
                ],
                [
                    'value' => request('name')[$locale] ? request('name')[$locale] : ""
                ]
            );

        }


        foreach (config('app.locales') as $locale) {
            $item->translates()->updateOrCreate(
                [
                    'language' => $locale,
                    'key' => 'description',
                ],
                [
                    'value' => request('description')[$locale] ? request('description')[$locale] : ""
                ]
            );

        }


        if (request()->is('api/*')) {
            return response()->json($item);
        } else {
            return redirect()->route('admin.banners.index')->with(['success' => 'تم ألتحديث بنجاح']);
        }
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param int $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        Banner::where('id',$id)->delete();

        return redirect()->route('admin.banners.index')->with(['success' => 'تم الحذف بنجاح']);
    }

}

app/Http/Controllers/Api/BannerController.php
<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\Controller;
use App\Models\Banner;

class BannerController extends Controller
{

    /**
     * Store a newly created resource in storage.
     *
     * @param \Illuminate\Http\Request $request
     * @return \Illuminate\Http\JsonResponse
     */
    public function index()
    {

        $banners = Banner::query();
        if(request('type')){
            $banners = $banners->where('type',request('type'));
        }
        $banners = $banners->get();
        return response()->json(['message' => 'success', "data" => $banners]);

    }
}

app/Http/Controllers/Api/DesignerController.php
<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\Controller;
use Spatie\Permission\Models\Role;

class DesignerController extends Controller
{

    public function index()
    {

        $role = Role::where('name',"Designer")->first();
        if(!$role){
            return response()->json(['message' => 'not exist']);
        }

        $users = $role->users;
        return response()->json(['message' => 'success', "data" => $users]);

    }

    public function show($id)
    {

        $role = Role::where('name',"Designer")->first();
        if(!$role){
            return response()->json(['message' => 'not exist']);
        }

        $user = $role->users->where('id',$id)->first();
        if(!$user){
            return response()->json(['message' => 'not exist']);
        }

        return response()->json(['message' => 'success', "data" => $user]);

    }


}

app/Http/Controllers/Designer/ConsultancyController.php
<?php

namespace App\Http\Controllers\Designer;

use App\Http\Controllers\Controller;
use App\Models\Consultancy;
use Illuminate\Http\Request;
use Illuminate\Support\Str;

class ConsultancyController extends Controller
{
    public function __construct()
    {
        $this->middleware(['permission:consultancies management']);
    }

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $items = Consultancy::where('user_id',auth()->id())->paginate(10);
        if (request()->is('api/*')) {
            return response()->json($items);
        } else {
            return view('designer.consultancies.index', compact('items'));
        }
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('designer.consultancies.add');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param \Illuminate\Http\Request $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {

        $validations = $request->validate([
            'name' => 'required',
            'description' => 'required',
            'image' => 'required|image',
        ]);

        if($request->image){
            $validations['image'] = $request->image->store('consultancies');
        }

        $validations['user_id'] = auth()->id();

        $item = Consultancy::create($validations);

        return redirect()->route('designer.consultancies.index')->with(['success' => __("Consultancy created")]);


    }

    /**
     * Display the specified resource.
     *
     * @param int $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param int $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $item = Consultancy::where('user_id',auth()->id())->where('id',$id)->firstOrFail($id);

        if (request()->is('api/*')) {
            return response()->json(['item' => $item]);
        } else {
            return view('designer.consultancies.edit', compact('item'));
        }

    }

    /**
     * Update the specified resource in storage.
     *
     * @param \Illuminate\Http\Request $request
     * @param int $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {


        $item = Consultancy::where('user_id',auth()->id())->where('id',$id)->firstOrFail($id);
        $data = [];
        if ($request->has('image')) {
            $data['image'] = $request->image->store('consultancies');
        }
        if ($request->has('name')) {
            $data['name'] = $request->name;
        }
        if ($request->has('description')) {
            $data['description'] = $request->description;
        }
        if ($request->status >= 0) {
            $data['status'] = $request->status;
        }

        $item->update($data);

        if (request()->is('api/*')) {
            return response()->json($item);
        } else {
            return redirect()->route('designer.consultancies.index')->with(['success' => __("Consultancy updated")]);
        }
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param int $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        Consultancy::where('id', $id)->delete();

        return redirect()->route('designer.consultancies.index')->with(['success' => __("Consultancy deleted")]);
    }

}

app/Http/Controllers/Designer/DashboardController.php
<?php

namespace App\Http\Controllers\Designer;

use App\Http\Controllers\Controller;
use App\Models\Setting;

use Illuminate\Support\Facades\Session;

class DashboardController extends Controller
{
    public function dashboard()
    {

        if (request('lang')) {
            Session::put('lang', request('lang'));
            app()->setLocale(request('lang'));
            return redirect()->back();
        }

        return view('designer.index');
    }

}

resources/views/designer/banners/add.blade.php
@extends('designer.layouts.app')
@section('title',__('Banners'))
@section('content')

    <div class="content-header row">
        <div class="content-header-left col-md-6 col-12 mb-2">
            <div class="row breadcrumbs-top">
                <div class="breadcrumb-wrapper col-12">
                    <ol class="breadcrumb">
                        <li class="breadcrumb-item"><a href="{{route('designer.home')}}">{{__('Home')}}</a></li>
                        <li class="breadcrumb-item"><a href=""> {{__('Banners')}}</a></li>
                        <li class="breadcrumb-item active"> {{__('Add banner')}}</li>
                    </ol>
                </div>
            </div>
        </div>
    </div>
    <div class="content-body">
        <!-- Basic form layout section start -->
        <section id="basic-form-layouts">
            <div class="row match-height">
                <div class="col-md-12">
                    <div class="card">
                        <div class="card-header">
                            <h4 class="card-title" id="basic-layout-form"> {{__('Add banner')}}</h4>
                            <a class="heading-elements-toggle"><i
                                    class="icon-ellipsis-v font-medium-3"></i></a>
                        </div>

                        <div class="card-content collapse show">
                            <div class="card-body">
                                <form class="form" action="{{route('designer.banners.store')}}" method="POST"
                                      enctype="multipart/form-data">
                                    @csrf
                                    <div class="form-group">
                                        <label> {{__('Banner image')}} </label>
                                        <label id="projectinput7" class="file center-block">
                                            <input type="file" id="image" name="image">
                                            <span class="file-custom"></span>
                                        </label>
                                        @error('image')
                                        <span class="text-danger">{{$message}}</span>
                                        @enderror
                                    </div>

                                    <div class="form-body">

                                        <h4 class="form-section"><i
                                                class="ft-home"></i> {{__('Banner details')}} </h4>

                                        <div class="form-group row">
                                            <label class="col-md-3 label-control"
                                                   for="url">{{__('Banner url')}}</label>
                                            <div class="col-md-9">
                                                <input type="text" id="url"
                                                       name="url"
                                                       class="form-control border-primary"
                                                       placeholder="{{__('Banner url')}}"
                                                       value="{{ old('url')}}">
                                            </div>
                                        </div>

                                        <div class="row">

                                            @foreach (config('app.locales') as $locale)
                                                <div class="col-md-6">
                                                    <div class="row">
                                                        <div class="col-md-12">
                                                            <div class="form-group row">
                                                                <label class="col-md-3 label-control"
                                                                       for="name">{{__('Banner name')}} @if(count(config('app.locales')) > 1)
                                                                        ({{__($locale)}}) @endif</label>
                                                                <div class="col-md-9">
                                                                    <input type="text" id="name[{{$locale}}]"
                                                                           name="name[{{$locale}}]"
                                                                           class="form-control border-primary"
                                                                           placeholder="{{__('Banner name')}} @if(count(config('app.locales')) > 1) ({{__($locale)}}) @endif"
                                                                           value="{{ old('name') ? old('name')[$locale] : '' }}">
                                                                </div>
                                                            </div>
                                                        </div>
                                                    </div>
                                                </div>
                                            @endforeach
                                        </div>
                                    </div>
                                    <div class="form-actions">
                                        <button type="button" class="btn btn-warning mr-1 block-page"
                                                onclick="history.back();">
                                            <i class="icon-cross"></i> {{__('Cancel')}}
                                        </button>
                                        <button type="submit" class="btn btn-primary block-page">
                                            <i class="icon-check"></i> {{__('Submit')}}</button>
                                    </div>
                                </form>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </section>
    </div>
@endsection

resources/views/designer/banners/edit.blade.php
@extends('designer.layouts.app')
@section('title',__('Banners'))
@section('content')
    <div class="content-header row">
        <div class="content-header-left col-md-6 col-12 mb-2">
            <div class="row breadcrumbs-top">
                <div class="breadcrumb-wrapper col-12">
                    <ol class="breadcrumb">
                        <li class="breadcrumb-item"><a href="{{route('designer.home')}}">{{__('Home')}} </a>
                        </li>
                        <li class="breadcrumb-item"><a href="{{route('designer.banners.index')}}"> {{__('Banners')}} </a>
                        </li>
                        <li class="breadcrumb-item active"> {{__('Edit banner')}} - {{$item -> name}}
                        </li>
                    </ol>
                </div>
            </div>
        </div>
    </div>
    <div class="content-body">
        <!-- Basic form layout section start -->
        <section id="basic-form-layouts">
            <div class="row match-height">
                <div class="col-md-12">
                    <div class="card">
                        <div class="card-header">
                            <h4 class="card-title" id="basic-layout-form"> {{__('Edit banner')}}</h4>
                            <a class="heading-elements-toggle"><i class="icon-ellipsis-v font-medium-3"></i></a>
                        </div>

                        <div class="card-content collapse show">
                            <div class="card-body">
                                <form class="form"
                                      action="{{route('designer.banners.update',$item -> id)}}"
                                      method="POST"
                                      enctype="multipart/form-data">
                                    @csrf
                                    @method('PUT')

                                    <div class="form-group">
                                        <div class="text-center">
                                            <img src="{{$item->image}}" class="image-edit-show"
                                                 alt="{{__('Banner Image')}} ">
                                        </div>
                                    </div>


                                    <div class="form-group">
                                        <label>{{__('Banner Image')}}</label>
                                        <label id="projectinput7" class="file center-block">
                                            <input type="file" id="file" name="image">
                                            <span class="file-custom"></span>
                                        </label>
                                        @error('image')
                                        <span class="text-danger">{{$message}}</span>
                                        @enderror
                                    </div>

                                    <div class="form-body">

                                        <h4 class="form-section"><i class="ft-home"></i> {{__('Banner Details')}}</h4>

                                        <div class="form-group row">
                                            <label class="col-md-3 label-control"
                                                   for="url">{{__('Banner url')}}</label>
                                            <div class="col-md-9">
                                                <input type="text" id="url"
                                                       name="url"
                                                       class="form-control border-primary"
                                                       placeholder="{{__('Banner url')}}"
                                                       value="{{ $item->url ? $item->url : '' }}">
                                            </div>
                                        </div>

                                        <div class="row">

                                            @foreach (config('app.locales') as $locale)
                                                <div class="col-md-6">
                                                    <div class="row">
                                                        <div class="col-md-12">
                                                            <div class="form-group row">
                                                                <label class="col-md-3 label-control"
                                                                       for="name">{{__('Banner name')}} @if(count(config('app.locales')) > 1)
                                                                        ({{__($locale)}}) @endif</label>
                                                                <div class="col-md-9">
                                                                    <input type="text" id="name[{{$locale}}]"
                                                                           name="name[{{$locale}}]"
                                                                           class="form-control border-primary"
                                                                           placeholder="{{__('Banner name')}} @if(count(config('app.locales')) > 1) ({{__($locale)}}) @endif"
                                                                           value="{{ $item->translate('name',$locale) }}">
                                                                </div>
                                                            </div>
                                                        </div>

                                                    </div>
                                                </div>
                                            @endforeach

                                        </div>

                                    </div>

                                    <div class="form-actions">
                                        <button type="button" class="btn btn-warning mr-1 block-page"
                                                onclick="history.back();">
                                            <i class="icon-cross"></i> {{__('Cancel')}}
                                        </button>
                                        <button type="submit" class="btn btn-primary block-page">
                                            <i class="icon-check"></i> {{__('Submit')}}</button>
                                    </div>
                                </form>
                            </div>
                        </div>
                    </div>
                </div>
            </div>

        </section>
    </div>
@endsection